#!/usr/bin/env python

#########################################################################
#                                                                       #
# Apathy - A telepathy based communications client for mobile platforms #
# Copyright (C) 2009  Michael Sheldon <mike@mikeasoft.com>              #
#                                                                       #
# This program is free software: you can redistribute it and/or modify  #
# it under the terms of the GNU General Public License as published by  #
# the Free Software Foundation, either version 3 of the License, or     #
# (at your option) any later version.                                   #
#                                                                       #
# This program is distributed in the hope that it will be useful,       #
# but WITHOUT ANY WARRANTY; without even the implied warranty of        #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
# GNU General Public License for more details.                          #
#                                                                       #
# You should have received a copy of the GNU General Public License     #
# along with this program.  If not, see <http://www.gnu.org/licenses/>. #
#                                                                       #
#########################################################################

import elementary, evas
from datetime import datetime

from gi.repository import TelepathyGLib as Tp

class Call(elementary.Box):
    def __init__(self, contact, channel, parent, apathy):
        elementary.Box.__init__(self, parent)
        self.contact = contact
        self.channel = channel

        self.apathy = apathy

        disconnect_button = elementary.Button(self)
        disconnect_button.text_set("Disconnect")
        disconnect_button.size_hint_weight_set(0.0, 0.0)
        disconnect_button.size_hint_align_set(-1.0, 0.0)
        disconnect_button.clicked = self.disconnect
        self.pack_end(disconnect_button)
        disconnect_button.show()

    def disconnect(self, obj, event, *args):
        print "Disconnect"
