#!/usr/bin/env python

#########################################################################
#                                                                       #
# Apathy - A telepathy based communications client for mobile platforms #
# Copyright (C) 2009  Michael Sheldon <mike@mikeasoft.com>              #
# Copyright 2012 Kai Huuhko <kai@kaihuuhko.com>                         #
#                                                                       #
# This program is free software: you can redistribute it and/or modify  #
# it under the terms of the GNU General Public License as published by  #
# the Free Software Foundation, either version 3 of the License, or     #
# (at your option) any later version.                                   #
#                                                                       #
# This program is distributed in the hope that it will be useful,       #
# but WITHOUT ANY WARRANTY; without even the implied warranty of        #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
# GNU General Public License for more details.                          #
#                                                                       #
# You should have received a copy of the GNU General Public License     #
# along with this program.  If not, see <http://www.gnu.org/licenses/>. #
#                                                                       #
#########################################################################

from elementary import *

class ErrorDialog(InnerWindow):
    def __init__(self, parent, title, *args):
        InnerWindow.__init__(self, parent)
        box0 = Box(parent)

        label = Entry(parent)
        label.editable_set(False)
        label.text_set(" ".join(args))

        frame = Frame(parent)
        frame.size_hint_align_set(-1.0, -1.0)
        frame.text_set(title)
        frame.content_set(label)
        box0.pack_end(frame)

        xbtn = Button(parent)
        xbtn.callback_clicked_add(self._destroy)
        xbtn.text_set(_("Close").encode("utf-8"))
        box0.pack_end(xbtn)

        xbtn.show()
        label.show()
        frame.show()

        box0.show()

        self.content_set(box0)
        self.style_set("minimal_vertical")

        self.activate()

    def _destroy(self, *args):
        self.hide()
