#!/usr/bin/env python

#########################################################################
#                                                                       #
# Apathy - A telepathy based communications client for mobile platforms #
# Copyright (C) 2009  Michael Sheldon <mike@mikeasoft.com>              #
# Copyright 2012 Kai Huuhko <kai@kaihuuhko.com>                         #
#                                                                       #
# This program is free software: you can redistribute it and/or modify  #
# it under the terms of the GNU General Public License as published by  #
# the Free Software Foundation, either version 3 of the License, or     #
# (at your option) any later version.                                   #
#                                                                       #
# This program is distributed in the hope that it will be useful,       #
# but WITHOUT ANY WARRANTY; without even the implied warranty of        #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
# GNU General Public License for more details.                          #
#                                                                       #
# You should have received a copy of the GNU General Public License     #
# along with this program.  If not, see <http://www.gnu.org/licenses/>. #
#                                                                       #
#########################################################################

import re

def parse(text, urls=True, emotes=True):
    text = text.replace("<br/>", "\n")
    text = text.replace("&", "&amp;")
    text = text.replace("<", "&lt;")
    text = text.replace(">", "&gt;")
    
    if urls:
        #URLs
        p = re.compile(r'(\b\S*://\S*\b)')
        text = p.sub(r'<a href=url:\1>\1</a>', text)
        
        #mail
        p = re.compile(r'(\b(\.|\w)*@\w*(\.|\w)*\b)')
        text = p.sub(r'<a href=mailto:\1>\1</a>', text)
    
    if emotes:
        #emoticons
        emoticons = {
            ":)": "happy",
            ":-)": "happy",
            ":D": "haha",
            ":-D": "haha",
            ";)": "wink",
            ";-)": "wink",
            ":-O": "omg",
            ":P": "tongue-dangling",
            ":-P": "tongue-dangling",
            "(H)": "smile",
            ":@": "",
            ":$": "",
            ":S": "",
            ":(": "sorry",
            ":'(": "very-sorry",
            ":|": "",
            "(6)": "evil",
            "(A)": "",
            "(L)": "love",
            "(U)": "",
            "(M)": "",
            "(@)": "",
            "(&)": "",
            "(S)": "",
            "(*)": "",
            "(~)": "",
            "(8)": "",
            "(E)": "",
            "(F)": "",
            "(W)": "",
            "(O)": "",
            "(K)": "kiss",
            "(G)": "",
            "(^)": "",
            "(P)": "",
            "(I)": "",
            "(C)": "",
            "(T)": "",
            "({)": "",
            "(})": "",
            "(B)": "",
            "(D)": "",
            "(Z)": "",
            "(X)": "",
            "(Y)": "",
            "(N)": "",
            ":[": "",
            "(nah)": "",
            "(#)": "",
            "(R)": "",
            ":-#": "",
            "8o|": "",
            "8-|": "",
            "^o)": "",
            ":-*": "",
            "+o(": "",
            "(sn)": "",
            "(tu)": "",
            "(pl)": "",
            "(||)": "",
            "(pi)": "",
            "(so)": "",
            "(au)": "",
            "(ap)": "",
            "(um)": "",
            "(ip)": "",
            "(co)": "",
            "(mp)": "",
            "(brb)": "",
            "(st)": "",
            "(h5)": "",
            "(mo)": "",
            "(bah)": "",
            ":^)": "",
            "*-)": "",
            "(li)": "",
            "<:o)": "",
            "8-)": "",
            "|-)": "",
            "('.')": "",
            "(ci)": "",
            "(%)": "",
            "(xx)": "",
            "(yn)": "",
        }
        for k, v in emoticons.iteritems():
            p = re.compile(re.escape(k))
            text = p.sub(r'<item size=32x32 vsize=full href=emoticon/%s></item>' % v, text)
            
    text = text.replace("\n", "<br/>")
    return text
