#!/usr/bin/env python

#########################################################################
#                                                                       #
# Apathy - A telepathy based communications client for mobile platforms #
# Copyright (C) 2009  Michael Sheldon <mike@mikeasoft.com>              #
# Copyright 2012 Kai Huuhko <kai@kaihuuhko.com>                         #
#                                                                       #
# This program is free software: you can redistribute it and/or modify  #
# it under the terms of the GNU General Public License as published by  #
# the Free Software Foundation, either version 3 of the License, or     #
# (at your option) any later version.                                   #
#                                                                       #
# This program is distributed in the hope that it will be useful,       #
# but WITHOUT ANY WARRANTY; without even the implied warranty of        #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
# GNU General Public License for more details.                          #
#                                                                       #
# You should have received a copy of the GNU General Public License     #
# along with this program.  If not, see <http://www.gnu.org/licenses/>. #
#                                                                       #
#########################################################################

import elementary as elm

from Globals import *

class PresenceEditor(object):
    def __init__(self, parent, pager):
        self.parentwin = parent
        self.pager = pager
                
        self.entries = {}

        self.conf = get_conf()
        messages = self.conf.items("StatusMessages")
        
        self.box = box = elm.Box(parent)

        for status, message in messages:
            frame = elm.Frame(parent)
            frame.size_hint_weight_set(1.0, 0.0)
            frame.size_hint_align_set(-1.0, -1.0)
            frame.text_set(status.capitalize())
            self.entries[status] = entry = elm.Entry(parent)
            entry.size_hint_weight_set(1.0, 1.0)
            entry.size_hint_align_set(-1.0, -1.0)
            entry.single_line_set(True)
            entry.text_set(message)
            frame.content_set(entry)
            box.pack_end(frame)
            entry.show()
            frame.show()
            
        box1 = elm.Box(parent)
        box1.horizontal_set(True)
        box1.size_hint_weight_set(1.0, 0.0)
        box1.size_hint_align_set(-1.0, 0.0)
            
        save_btn = elm.Button(parent)
        save_btn.size_hint_weight_set(1.0, 0.0)
        save_btn.size_hint_align_set(-1.0, 0.0)
        save_btn.text_set(_("Save"))
        save_btn.callback_clicked_add(self.save)
        box1.pack_end(save_btn)
        save_btn.show()
        
        xbtn = elm.Button(parent)
        xbtn.size_hint_weight_set(1.0, 0.0)
        xbtn.size_hint_align_set(-1.0, 0.0)
        xbtn.text_set(_("Close"))
        xbtn.callback_clicked_add(lambda x: pager.item_pop())
        box.pack_end(xbtn)
        xbtn.show()
        
        box.pack_end(box1)
        box.show()

    def save(self, obj, *args):
        for status, entry in self.entries.iteritems():
            message = entry.entry_get()
            self.conf.set("StatusMessages", status, message)
        with open(conf_path, 'wb') as configfile:
            self.conf.write(configfile)
        self.pager.item_pop()
